/*******************************************************************************
 * Copyright (c) 2000 IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

package org.eclipse.stp.core.internal;

import org.eclipse.osgi.util.NLS;

public class Messages extends NLS {
   private static final String BUNDLE_NAME = "org.eclipse.stp.core.internal.messages";               //$NON-NLS-1$

   public static String        referenceName_not_inComponentType;

   public static String        serviceName_not_inComponentType;

   public static String        propertyName_not_inComponentType;

   public static String        Name_Already_Exists;

   // Service Component creation messages
   public static String        ServiceComponentWizard_componentTypeEmpty_errorText;

   public static String        ServiceComponentWizard_implementationFilePathEmpty_errorText;

   public static String        ServiceComponentWizard_implementationContainerLocationEmpty_errorText;

   public static String        ServiceComponentWizard_componentContainerLocationEmpty_errorText;

   // Part creation related messages
   public static String        componentDescriptionField_text;

   public static String        importDescriptionField_text;

   public static String        exportDescriptionField_text;

   public static String        moduleDescriptionField_text;

   public static String        componentName_prefix;

   // Implementation related messages
   public static String        fileNotSupportedForImplementation_errorText;

   // General messages
   public static String        invalidObjectPassed_errorText;

   public static String        portionOfNameNotValid_errorText;

   public static String        nameNotValid_errorText;

   public static String        containerNotExisting_errorText;

   public static String        nameAlreadyInUse_errorText;

   public static String        nameBlank_errorText;

   public static String        nameHasConsecutiveEmbeddedBlanks_errorText;

   // Edit related
   public static String        newNameBlank_errorText;

   // Wire related messages
   public static String        wireTargetNameInValid_errorText;

   public static String        wireTargetNameBlank_errorText;

   public static String        wireSourceInvalid_errorText;

   // Interface Creation related error messages
   public static String        interfaceExistInComponent_errorText;

   // Reference Creation related error messages
   public static String        referenceNameAlreadyUsedInComponent_errorText;

   public static String        Attempt_to_modify_an_SCA_;

   public static String        DataModel_could_not_be_c_;

   public static String        Existing_name_is_same_as_;

   public static String        IComponentTypeIntrospector_missing_one;

   public static String        Could_not_create_class;

   public static String        Model_consistency_status_message;

   public static String        Fileset_for_Module_;

   static {
      NLS.initializeMessages(BUNDLE_NAME, Messages.class);
   }

}
